// Copyright (c) [2024] SUSE LLC
//
// All Rights Reserved.
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, contact SUSE LLC.
//
// To contact SUSE LLC about this file by physical or electronic mail, you may
// find current contact information at www.suse.com.

//! # D-Bus interface proxy for: `org.opensuse.Agama1.Registration`
//!
//! This code was generated by `zbus-xmlgen` `5.0.0` from D-Bus introspection data.
//! Source: `org.opensuse.Agama.Software1.Product.bus.xml`.
//!
//! You may prefer to adapt it, instead of using it verbatim.
//!
//! More information can be found in the [Writing a client proxy] section of the zbus
//! documentation.
//!
//! This type implements the [D-Bus standard interfaces], (`org.freedesktop.DBus.*`) for which the
//! following zbus API can be used:
//!
//! * [`zbus::fdo::PropertiesProxy`]
//! * [`zbus::fdo::IntrospectableProxy`]
//!
//! Consequently `zbus-xmlgen` did not generate code for the above interfaces.
//!
//! [Writing a client proxy]: https://dbus2.github.io/zbus/client.html
//! [D-Bus standard interfaces]: https://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces,
use zbus::proxy;
#[proxy(
    default_service = "org.opensuse.Agama.Software1",
    default_path = "/org/opensuse/Agama/Software1/Product",
    interface = "org.opensuse.Agama1.Registration",
    assume_defaults = true
)]
pub trait Registration {
    /// Deregister method
    fn deregister(&self) -> zbus::Result<(u32, String)>;

    /// Register method
    fn register(
        &self,
        reg_code: &str,
        options: std::collections::HashMap<&str, &zbus::zvariant::Value<'_>>,
    ) -> zbus::Result<(u32, String)>;

    /// Register addon method
    fn register_addon(
        &self,
        name: &str,
        version: &str,
        reg_code: &str,
    ) -> zbus::Result<(u32, String)>;

    /// Email property
    #[zbus(property)]
    fn email(&self) -> zbus::Result<String>;

    /// RegCode property
    #[zbus(property)]
    fn reg_code(&self) -> zbus::Result<String>;

    /// registered addons property, list of tuples (name, version, reg_code))
    #[zbus(property)]
    fn registered_addons(&self) -> zbus::Result<Vec<(String, String, String)>>;
}
