// Copyright (c) [2024] SUSE LLC
//
// All Rights Reserved.
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, contact SUSE LLC.
//
// To contact SUSE LLC about this file by physical or electronic mail, you may
// find current contact information at www.suse.com.

//! # D-Bus interface proxy for: `org.opensuse.Agama.Storage1.ZFCP.Controller`
//!
//! This code was generated by `zbus-xmlgen` `5.0.0` from D-Bus introspection data.
//! Source: `org.opensuse.Agama.Storage1.ZFCP.Controller.bus.xml`.
//!
//! You may prefer to adapt it, instead of using it verbatim.
//!
//! More information can be found in the [Writing a client proxy] section of the zbus
//! documentation.
//!
//! This type implements the [D-Bus standard interfaces], (`org.freedesktop.DBus.*`) for which the
//! following zbus API can be used:
//!
//! * [`zbus::fdo::PropertiesProxy`]
//! * [`zbus::fdo::IntrospectableProxy`]
//!
//! Consequently `zbus-xmlgen` did not generate code for the above interfaces.
//!
//! [Writing a client proxy]: https://dbus2.github.io/zbus/client.html
//! [D-Bus standard interfaces]: https://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces,
use zbus::proxy;
#[proxy(
    default_service = "org.opensuse.Agama.Storage1",
    default_path = "/org/opensuse/Agama/Storage1",
    interface = "org.opensuse.Agama.Storage1.ZFCP.Controller",
    assume_defaults = true
)]
pub trait Controller {
    /// Activate method
    fn activate(&self) -> zbus::Result<u32>;

    /// ActivateDisk method
    fn activate_disk(&self, wwpn: &str, lun: &str) -> zbus::Result<u32>;

    /// DeactivateDisk method
    fn deactivate_disk(&self, wwpn: &str, lun: &str) -> zbus::Result<u32>;

    /// GetLUNs method
    #[zbus(name = "GetLUNs")]
    fn get_luns(&self, wwpn: &str) -> zbus::Result<Vec<String>>;

    /// GetWWPNs method
    #[zbus(name = "GetWWPNs")]
    fn get_wwpns(&self) -> zbus::Result<Vec<String>>;

    /// Active property
    #[zbus(property)]
    fn active(&self) -> zbus::Result<bool>;

    /// Channel property
    #[zbus(property)]
    fn channel(&self) -> zbus::Result<String>;

    /// LUNScan property
    #[zbus(property, name = "LUNScan")]
    fn lunscan(&self) -> zbus::Result<bool>;
}
